#import <Foundation/Foundation.h>
#import "RawImage.h"
#import "RawSample.h"

/**
	@defgroup SwiftAPI
	@{
*/

/**
	\~English
	\brief Interface object for detecting or tracking of faces in the images or video sequences.
	\~Russian
	\brief Интерфейсный объект для детекции и трекинга лиц на изображениях или видеопоследовательностях.
*/
@interface Capturer : NSObject
{
    void *capturer;
}

-(nonnull instancetype) init: (void*_Nonnull) cap;
-(void) dealloc;

/**
		\~English
		\brief
			Capture faces in a given image or video frame.

		\param[in]  raw_image
			Image or videoframe.

		\return
			Vector of captured face samples.

		\warning
			Gray-scale images are not supported by the objects created with some configuration files.

		\~Russian
		\brief
			Детектировать (и отследить) лица на изображении (кадре видео).

		\param[in]  raw_image
			Изображение или кадр видео.

		\return
			Вектор найденных лиц.

		\warning
			Черно-белые изображения не поддерживаются объектами, созданными с некоторыми конфигурационными файлами.
	*/
-(nonnull NSMutableArray *) capture: (RawImage *_Nonnull) raw_image ;

@property void * _Nullable capturer;

@end

/** @} */