#import <Foundation/Foundation.h>
#import <Context.h>

/**
	@defgroup SwiftAPI
	@{
*/


/**
	\~English
	\brief Interface object used to work with estimators from Processing Block API.
	\~Russian
	\brief Интерфейсный объект для взаимодействия с методами из Processing Block API.
*/
@interface ProcessingBlock : NSObject
{
    void *ptr;
}
-(nonnull instancetype) init: (void* _Nonnull) pb;
-(void) dealloc;

/**
	\~English
	\brief
		Calling the processing block function.
	\param[in]  сtx Context
	\~Russian
	\brief
		Вызов функции процессинг-блока.
	\param[in]  сtx Context
*/
-(void) process: (Context* _Nonnull) data;


@end


/** @} */
