#import <Foundation/Foundation.h>

/**
	@defgroup SwiftAPI
	@{
*/

/** \~English
	\brief Interface object for saving the face template.
	\~Russian
	\brief Интерфейсный объект для сохранения шаблона лица.
*/
@interface Template : NSObject
{
    void *_template;
}
-(nonnull instancetype) init: (void* _Nonnull) temp;
-(void) dealloc;

/**
	\~English
	\brief
		Get a method name.
		Thread-safe.

	\return
		The name of the method that created this template.

	\~Russian
	\brief
		Получить имя метода.
		Потокобезопасный.

	\return
		Имя метода, создавшего этот шаблон.
*/
-(nonnull NSString *) getMethodName;

/**
	\~English
	\brief
		Save the template to binary_stream.
		The format is platform-independent.
		Thread-safe.

	\param[out]  file_path

	\~Russian
	\brief
		Сохранить шаблон.
		Формат платформонезависимый.
		Потокобезопасный.

	\param[out]  file_path
	*/
-(void) save: (const char* _Nonnull) file_path;


@property (readonly, nonnull) void *_template;
@end

/** @} */